#!/usr/bin/env python

import glob, os, sys

# The next statements assure importation of qwt from the
# local source tree. This is useful for debugging and testing.
globs = glob.glob('../build/lib.*/qwt')
if globs:                               # found PyQwt modules made by distutils
    sys.path.insert(0, os.path.split(globs[0])[0])

from qt import *
from qwt import *
from Numeric import *

from LegendBaseDialog import LegendBaseDialog

# FIXME: clean up, this MESS
class LegendDialog(LegendBaseDialog):

    def __init__(self):
        LegendBaseDialog.__init__(self)
        self.plot.setPlotBackground(Qt.white)
        self.curve0 = self.plot.insertCurve('sin(x+0*pi/2)')
        self.curve1 = self.plot.insertCurve('sin(x+1*pi/2)')
        self.curve2 = self.plot.insertCurve('sin(x+2*pi/2)')
        self.curve3 = self.plot.insertCurve('sin(x+3*pi/2)')
        self.plot.setCurvePen(self.curve0, QPen(Qt.black))
        self.plot.setCurvePen(self.curve1, QPen(Qt.red))
        self.plot.setCurvePen(self.curve2, QPen(Qt.blue))
        self.plot.setCurvePen(self.curve3, QPen(Qt.green))
        x = arrayrange(0.0, 10.0, 0.1)
        y0 = sin(x+0*pi/2)
        y1 = sin(x+1*pi/2)
        y2 = sin(x+2*pi/2)
        y3 = sin(x+3*pi/2)        
        self.plot.setCurveData(self.curve0, x, y0)
        self.plot.setCurveData(self.curve1, x, y1)
        self.plot.setCurveData(self.curve2, x, y2)
        self.plot.setCurveData(self.curve3, x, y3)
        self.plot.enableLegend(1)
        self.checkLegend0.setChecked(1)
        self.checkLegend1.setChecked(1)
        self.checkLegend2.setChecked(1)
        self.checkLegend3.setChecked(1)
        #self.checkAllLegends.setChecked(1)

    def legend0Clicked(self):
        self.plot.enableLegend(self.checkLegend0.isChecked(), self.curve0)

    def legend1Clicked(self):
        self.plot.enableLegend(self.checkLegend1.isChecked(), self.curve1)

    def legend2Clicked(self):
        self.plot.enableLegend(self.checkLegend2.isChecked(), self.curve2)

    def legend3Clicked(self):
        self.plot.enableLegend(self.checkLegend3.isChecked(), self.curve3)

    def enableAllClicked(self):
        self.plot.enableLegend(1)
        self.checkLegend0.setChecked(1)
        self.checkLegend1.setChecked(1)
        self.checkLegend2.setChecked(1)
        self.checkLegend3.setChecked(1)

    def disableAllClicked(self):
        self.plot.enableLegend(0)
        self.checkLegend0.setChecked(0)
        self.checkLegend1.setChecked(0)
        self.checkLegend2.setChecked(0)
        self.checkLegend3.setChecked(0)


# Admire!
app = QApplication(sys.argv)
demo = LegendDialog()
app.setMainWidget(demo)
demo.show()
app.exec_loop()
