#define private public
#include <qwt_curve.h>
#undef private

#include <qwt_plot.h>
#include <qwt_plot_dict.h>
#include "dirtyplot.h"

class DirtyCurve: public QwtPlotCurve
{
public:
	void appendData(double *x, double *y, int size);

private:
	DirtyCurve(): QwtPlotCurve(0)  {}; // dummy for the compiler
};

void DirtyCurve::appendData(double *x, double *y, int size)
{
    // This one is very dirty and questionable implementation
    // as it is based on the knolledge of the internal implementation
	// of QwtPlotCurve

    if (d_xraw || d_yraw)
        setData(x, y, size);
    else
    {
        int offset = d_x.size();

        d_x.resize(d_x.size() + size);
        d_y.resize(d_y.size() + size);

        for ( int i = 0; i < size; i++ )
        {
            d_x[offset + i] = x[i];
            d_y[offset + i] = y[i];
        }
        hasErrors = FALSE;
        curveChanged();
    }
}

RealtimePlot::RealtimePlot(QWidget *parent, const char* name): 
	IncrementalPlot(parent, name)
{
}

void RealtimePlot::appendCurveData(long curveId,
	double *x, double *y, int size)
{
    DirtyCurve *curve = (DirtyCurve *)d_curves->find(curveId);
	if ( curve == 0 || size <= 0 )
		return;

	curve->appendData(x, y, size);
}
